#include <SDL.h>
#include <stdbool.h>

int main(int argc, char ** argv) {

  SDL_Window * ventana;
  SDL_Renderer * render;
  SDL_Event evento;
  bool quit = false;

  // El color inicial de la barra será negro como el fondo. Será una barra que cambiaremos de color y repetiremos en el eje y.
  int r,g,b,a;
  r = 1;
  g = 1;
  b = 1;
  a = 255;

  // La posición inicial
  int x,y;
  x = 0;
  y = 0;

  SDL_Rect barra;
  barra.x = 0;
  barra.y = 0;
  barra.w = 320;
  barra.h = 1;

  SDL_Init(SDL_INIT_VIDEO);
  Uint32 flags = SDL_WINDOW_OPENGL; // Otros ejemplos SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE | ...
  ventana = SDL_CreateWindow("degradado",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED,320,255,flags);

  if (ventana == NULL) { printf("No se pudo crear la ventana: %s\n", SDL_GetError());	return 1; }

  render = SDL_CreateRenderer(ventana, -1, 0);

  // Para que se vea lo meto en 3 for. Este primero mostrará degradado rojo
  int z;
  for (z = 1; z < 255; z++) {
    r = z; g = 0; b = 0;
    barra.y = y;
    SDL_SetRenderDrawColor(render, r, g, b, a);
    SDL_RenderFillRect(render, &barra);
    SDL_RenderDrawPoint(render, x, y);
    y = y+1;
  }

  SDL_RenderPresent(render);
  SDL_Delay(1000);
  y=0;

  // Este segundo mostrará un degradado verde
  for (z = 1; z < 255; z++) {
    r = 1; g = z; b = 0;
    barra.y = y;
    SDL_SetRenderDrawColor(render, r, g, b, a);
    SDL_RenderFillRect(render, &barra);
    SDL_RenderDrawPoint(render, x, y);
    y = y+1;
  }

  SDL_RenderPresent(render);
  SDL_Delay(1000);
  y=0;

  // Este tercero mostrará un degradado azul
  for (z = 1; z < 255; z++) {
    r = 1; g = 1; b = z;
    barra.y = y;
    SDL_SetRenderDrawColor(render, r, g, b, a);
    SDL_RenderFillRect(render, &barra);
    SDL_RenderDrawPoint(render, x, y);
    y = y+1;
  }

  SDL_RenderPresent(render);

  while (!quit) {
    SDL_WaitEvent(&evento);
    switch (evento.type) {
    case SDL_QUIT:
      quit = true;
      break;
    }

  }

}
